<template>
  <div
    :id="errorsId"
    class="ui-form-errors"
    aria-live="assertive"
    aria-relevant="all"
  >
    <ui-transition-expand>
      <div v-if="errors.length">
        <p
          class="errors not-prose m-0 flex flex-col rounded border-2 border-red-400 bg-red-50 p-2 leading-relaxed text-red-800 empty:hidden"
        >
          <span v-for="(error, index) of errors.filter(Boolean)" :key="index">
            <span aria-hidden="true">↪</span> {{ error
            }}<span
              v-if="![',', '.', '!'].includes(error[error.length - 1])"
              class="sr-only"
              >.</span
            >
          </span>
        </p>
      </div>
    </ui-transition-expand>
  </div>
</template>

<script lang="ts" setup>
import { PropType } from 'vue'
import UiTransitionExpand from './transition/Expand.vue'

defineOptions({
  name: 'UiFormErrors',
})

defineProps({
  errorsId: {
    type: String,
    default: undefined,
  },
  errors: {
    type: Array as PropType<string[]>,
    default: () => [],
    validate: (array: []) => array.every((item) => typeof item === 'string'),
  },
})
</script>
